// -------------------------------------------------------------------------------
// 
// 		cwCu		R[h֌WvOwb_t@C
// 
// 				Ver 3.15a
// 
// -------------------------------------------------------------------------------

#ifndef __DXCHAR_H__
#define __DXCHAR_H__

// CN[h ------------------------------------------------------------------
#include "DxCompileConfig.h"
#include "DxLib.h"
#include "DxStatic.h"

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` --------------------------------------------------------------------

// VtgJISQoCg
#define CHECK_SHIFTJIS_2BYTE( x )			( ( BYTE )( ( ( ( BYTE )(x) ) ^ 0x20) - ( BYTE )0xa1 ) < 0x3c )

// UTF16LETQ[gyA( gGfBAp )
#define CHECK_CPU_LE_UTF16LE_4BYTE( x )		( ( ( x ) & 0xfc00 ) == 0xd800 )

// UTF16LETQ[gyA( rbOGfBAp )
#define CHECK_CPU_BE_UTF16LE_4BYTE( x )		( ( ( ( ( ( ( WORD )( x ) ) >> 8 ) & 0xff ) | ( ( ( WORD )( x ) << 8 ) & 0xff00 ) ) & 0xfc00 ) == 0xd800 )

// UTF16BETQ[gyA( gGfBAp )
#define CHECK_CPU_LE_UTF16BE_4BYTE( x )		CHECK_CPU_BE_UTF16LE_4BYTE( x )

// UTF16BETQ[gyA( rbOGfBAp )
#define CHECK_CPU_BE_UTF16BE_4BYTE( x )		CHECK_CPU_LE_UTF16LE_4BYTE( x )

// wchar_t TQ[gyA( UTF-32 or UTF-16 z )
#ifdef WCHAR_T_BE
	#define CHECK_WCHAR_T_DOUBLE( x )	( sizeof( wchar_t ) == 2 && ( ( ( WORD )( x ) & 0x00fc ) == 0x00d8 ) )
#else
	#define CHECK_WCHAR_T_DOUBLE( x )	( sizeof( wchar_t ) == 2 && ( ( ( WORD )( x ) & 0xfc00 ) == 0xd800 ) )
#endif

// \̒` --------------------------------------------------------------------

// UTF-16ƊeR[h̑Ή\̏
struct CHARCODETABLEINFO
{
	WORD				MultiByteToUTF16[ 0x10000 ] ;		// eR[hUTF-16ɕϊ邽߂̃e[u
	WORD				UTF16ToMultiByte[ 0x10000 ] ;		// UTF-16eR[hɕϊ邽߂̃e[u
} ;

// R[h֌WŎgp
struct CHARCODESYSTEM
{
	int					InitializeFlag ;					// sǂ( TRUE:s  FALSE:sĂȂ )

	CHARCODETABLEINFO	CharCodeCP932Info ;					// Shift-JIS̕R[h
	CHARCODETABLEINFO	CharCodeCP936Info ;					// GB2312̕R[h
	CHARCODETABLEINFO	CharCodeCP949Info ;					// UHC̕R[h
	CHARCODETABLEINFO	CharCodeCP950Info ;					// BIG5̕R[h
} ;

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

extern CHARCODESYSTEM g_CharCodeSystem ;

// ֐vg^Cv錾-----------------------------------------------------------

extern	int				InitCharCode( void ) ;																			// R[h֘Ȁs

extern	int				GetCharCodeFormatUnitSize(	int CharCodeFormat ) ;														// w̕R[h`̏ŏTCY擾( ߂lFoCg )
extern	int				GetCharBytes(			const char *CharCode, int CharCodeFormat ) ;									// P̃oCg擾( ߂lFP̃oCg )
extern	DWORD			GetCharCode(			const char *CharCode, int CharCodeFormat, int *CharBytes ) ;					// P̕R[hƕ̃oCg擾
extern	int				PutCharCode(			DWORD CharCode, int CharCodeFormat, char *Dest ) ;							// R[hʏ̕ɕϊAI[Ƀk͏܂Ȃ( ߂lF񂾃oCg )
extern	DWORD			ConvCharCode(			DWORD SrcCharCode, int SrcCharCodeFormat, int DestCharCodeFormat ) ;				// R[hw̕R[h`̕ɕϊ
extern	int				ConvCharCodeString(		const DWORD *Src, int SrcCharCodeFormat, DWORD *Dest, int DestCharCodeFormat ) ;	// PSoCg̔zAʕR[h`̂PSoCg̔zɕϊ( ߂lFϊ̃TCYAk܂( PʁFoCg ) )
extern	int				StringToCharCodeString( const char  *Src, int SrcCharCodeFormat, DWORD  *Dest ) ;						// PSoCg̔zɕϊ( ߂lFϊ̃TCYAk܂( PʁFoCg ) )
extern	int				CharCodeStringToString( const DWORD *Src, char *Dest, int DestCharCodeFormat ) ;						// PSoCg̔z𕶎ɕϊ( ߂lFϊ̃TCYAk܂( PʁFoCg ) )
extern	int				ConvString(				const char *Src, int SrcCharCodeFormat, char *Dest, int DestCharCodeFormat ) ;		// w̕R[h`̕ɕϊ( ߂lFϊ̃TCYAk܂( PʁFoCg ) )
extern	int				GetStringCharNum(		const char *String, int CharCodeFormat ) ;									// Ɋ܂܂镶擾
extern	const char *	GetStringCharAddress(	const char *String, int CharCodeFormat, int Index ) ;							// wԍ̃̕AhX擾
extern	DWORD			GetStringCharCode(		const char *String, int CharCodeFormat, int Index ) ;							// wԍ̃̕R[h擾

extern	void			CL_strcpy(            int CharCodeFormat, char *Dest, const char *Src ) ;
extern	void			CL_strpcpy(           int CharCodeFormat, char *Dest, const char *Src, int Pos ) ;
extern	void			CL_strpcpy2(          int CharCodeFormat, char *Dest, const char *Src, int Pos ) ;
extern	void			CL_strncpy(           int CharCodeFormat, char *Dest, const char *Src, int Num ) ;
extern	void			CL_strncpy2(          int CharCodeFormat, char *Dest, const char *Src, int Num ) ;
extern	void			CL_strrncpy(          int CharCodeFormat, char *Dest, const char *Src, int Num ) ;
extern	void			CL_strrncpy2(         int CharCodeFormat, char *Dest, const char *Src, int Num ) ;
extern	void			CL_strpncpy(          int CharCodeFormat, char *Dest, const char *Src, int Pos, int Num ) ;
extern	void			CL_strpncpy2(         int CharCodeFormat, char *Dest, const char *Src, int Pos, int Num ) ;
extern	void			CL_strcat(            int CharCodeFormat, char *Dest, const char *Src ) ;
extern	int				CL_strlen(            int CharCodeFormat, const char *Str ) ;
extern	int				CL_strlen2(           int CharCodeFormat, const char *Str ) ;
extern	int				CL_strcmp(            int CharCodeFormat, const char *Str1, const char *Str2 ) ;
extern	int				CL_stricmp(           int CharCodeFormat, const char *Str1, const char *Str2 ) ;
extern	int				CL_strcmp_str2_ascii( int CharCodeFormat, const char *Str1, const char *Str2 ) ;
extern	int				CL_strncmp(           int CharCodeFormat, const char *Str1, const char *Str2, int Num ) ;
extern	int				CL_strncmp2(          int CharCodeFormat, const char *Str1, const char *Str2, int Num ) ;
extern	int				CL_strpncmp(          int CharCodeFormat, const char *Str1, const char *Str2, int Pos, int Num ) ;
extern	int				CL_strpncmp2(         int CharCodeFormat, const char *Str1, const char *Str2, int Pos, int Num ) ;
extern	DWORD			CL_strgetchr(         int CharCodeFormat, const char *Str, int Pos, int *CharNums ) ;
extern	DWORD			CL_strgetchr2(        int CharCodeFormat, const char *Str, int Pos, int *CharNums ) ;
extern	int				CL_strputchr(         int CharCodeFormat, char *Str, int Pos, DWORD CharCode ) ;
extern	int				CL_strputchr2(        int CharCodeFormat, char *Str, int Pos, DWORD CharCode ) ;
extern	const char *	CL_strpos(            int CharCodeFormat, const char *Str, int Pos ) ;
extern	const char *	CL_strpos2(           int CharCodeFormat, const char *Str, int Pos ) ;
extern	const char *	CL_strstr(            int CharCodeFormat, const char *Str1, const char *Str2 ) ;
extern	int				CL_strstr2(           int CharCodeFormat, const char *Str1, const char *Str2 ) ;
extern	const char *	CL_strrstr(           int CharCodeFormat, const char *Str1, const char *Str2 ) ;
extern	int				CL_strrstr2(          int CharCodeFormat, const char *Str1, const char *Str2 ) ;
extern	const char *	CL_strchr(            int CharCodeFormat, const char *Str, DWORD CharCode ) ;
extern	int				CL_strchr2(           int CharCodeFormat, const char *Str, DWORD CharCode ) ;
extern	const char *	CL_strrchr(           int CharCodeFormat, const char *Str, DWORD CharCode ) ;
extern	int				CL_strrchr2(          int CharCodeFormat, const char *Str, DWORD CharCode ) ;
extern	char *			CL_strupr(            int CharCodeFormat, char *Str ) ;
extern	int				CL_vsprintf(          int CharCodeFormat, int IsWChar, int CharCharCodeFormat, int WCharCharCodeFormat, char *Buffer, const char *FormatString, va_list Arg ) ;
extern	int				CL_sprintf(           int CharCodeFormat, int IsWChar, int CharCharCodeFormat, int WCharCharCodeFormat, char *Buffer, const char *FormatString, ... ) ;
extern	char *			CL_itoa(              int CharCodeFormat, int Value, char *Buffer, int Radix ) ;
extern	int				CL_atoi(              int CharCodeFormat, const char *Str ) ;
extern	double			CL_atof(              int CharCodeFormat, const char *Str ) ;
extern	int				CL_vsscanf(           int CharCodeFormat, int IsWChar, int CharCharCodeFormat, int WCharCharCodeFormat, const char *String, const char *FormatString, va_list Arg ) ;
extern	int				CL_sscanf(            int CharCodeFormat, int IsWChar, int CharCharCodeFormat, int WCharCharCodeFormat, const char *String, const char *FormatString, ... ) ;

#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif // __DXCHAR_H__
