// -------------------------------------------------------------------------------
// 
// 		cwCu		TEhf[^ϊvOwb_t@C
// 
// 				Ver 3.15a
// 
// -------------------------------------------------------------------------------

#ifndef __DXSOUNDCONVERT_H__
#define __DXSOUNDCONVERT_H__

#include "DxCompileConfig.h"

// CN[h ------------------------------------------------------------------

#include "DxLib.h"

#ifdef __WINDOWS__
	#include "Windows/DxSoundConvertWin.h"
#endif // __WINDOWS__

#ifdef __PSVITA
	#include "PSVita/DxSoundConvertPSVita.h"
#endif // __PSVITA

#ifdef __PS4
	#include "PS4/DxSoundConvertPS4.h"
#endif // __PS4

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` --------------------------------------------------------------------

// ^Cv
#define SOUND_METHODTYPE_NORMAL				(0)		// ʏ̏(ʂȏ͋܂Ȃ)
#define SOUND_METHODTYPE_OGG				(1)		// nffgp
#define SOUND_METHODTYPE_DEFAULT_NUM		(2)		// ɈˑȂ^Cv̐

// `NhcZbg}N
#define RIFFCHUNKID( C1 , C2 , C3 , C4 )	( DWORD )( ((( DWORD )C4)<<24) | ((( DWORD )C3)<<16) | ((( DWORD )C2)<<8) | (C1) ) 

#ifndef WAVE_FORMAT_IEEE_FLOAT
#define WAVE_FORMAT_IEEE_FLOAT		0x0003
#endif

#ifndef WAVE_FORMAT_PCM
#define WAVE_FORMAT_PCM				0x0001
#endif

// \̒` --------------------------------------------------------------------

// RIFF`Nf[^
struct ___RIFFCHUNK
{
	DWORD						fcc ;
	DWORD						 cb ;
} ;

// v`udf[^ϊp\
struct SOUNDCONV_WAVE
{
	BYTE						*SrcBuffer ;		// ϊ̃f[^
	DWORD						SrcBufferSize ;		// ϊobt@̃f[^TCY
	DWORD						SrcSampleNum ;		// ϊobt@̃Tv
	WAVEFORMATEX				SrcFormat ;			// ϊobt@̃tH[}bg
} ;

// f[^ϊp\
struct SOUNDCONV
{
	int							InitializeFlag ;		// ĂꍇɗtO
	int							EndFlag ;				// ϊI痧tO
	
	int 						MethodType ;			// ^Cv( SOUND_METHODTYPE_NORMAL  )
	STREAMDATA 					Stream ;				// f[^ǂݍݗpXg[f[^

	int							HeaderPos ;				// wb_̂ʒu
	int							HeaderSize ;			// wb_̃TCY
	int							DataPos ;				// f[^̂ʒu
	int							DataSize ;				// f[^̃TCY

	WAVEFORMATEX				OutFormat ;				// ϊ̃tH[}bg

	char						ConvFunctionBuffer[ 1024 ] ;	// MethodType ʃf[^ۑpobt@̈

	void						*DestData ;				// ϊ̃f[^ꎞIɕۑ郁̈
	int							DestDataSize ;			// ϊ̃f[^ꎞIɕۑ郁̈̃TCY
	int							DestDataValidSize ;		// ϊ̃f[^̗LȃTCY
	int							DestDataCompSize ;		// ϊ̃f[^ꎞIɕۑ郁̈撆̓]ς݂̃TCY
	int							DestDataCompSizeAll ;	// ϊJn猻݂Ɏ܂łɓ]f[^̃TCY

	int							SeekLockPosition ;		// \V[Nʒu(`bl^CvŃ[vꍇׂ̈̃f[^)
#ifndef DX_NON_OGGVORBIS
	int							OggVorbisBitDepth ;			// nugp̃rbg[x(1:8bit 2:16bit)
	int							OggVorbisFromTheoraFile ;	// Ogg Theora t@C Vorbis f[^QƂ邩ǂ̃tO( TRUE:Theora t@C Vorbis f[^QƂ )
#endif
} ;

// ֐vg^Cv錾-----------------------------------------------------------

// EI֐
extern	int InitializeSoundConvert( void ) ;														// TEhf[^ϊ̏s
extern	int TerminateSoundConvert( void ) ;															// TEhf[^ϊ̏Is

// tH[}bgϊp
extern	int SetupSoundConvert( SOUNDCONV *SoundConv, STREAMDATA *Stream, int DisableReadSoundFunctionMask = 0, int OggVorbisBitDepth = 2, int OggVorbisFromTheoraFile = FALSE ) ;	// ϊ̃ZbgAbv( [] -1:G[ )
//extern	int SetTimeSoundConvert(      SOUNDCONV *SoundConv, int Time ) ;						// ϊ̈ʒuύX( ~bP )
extern	int SetSampleTimeSoundConvert(    SOUNDCONV *SoundConv, int SampleTime ) ;					// ϊ̈ʒuύX( TvP )
extern	int SetupSeekPosSoundConvert(     SOUNDCONV *SoundConv, int SeekPos ) ;						// V[N\̈ʒuZbgĂ(`blׂ̈)
extern	int RunSoundConvert(              SOUNDCONV *SoundConv, void *DestBuffer, int DestSize ) ;	// w̃TCY( [] -1:G[  0ȏ:ϊTCY )
extern	int TerminateSoundConvert(        SOUNDCONV *SoundConv ) ;									// ϊ̌ns
extern	int GetOutSoundFormatInfo(        SOUNDCONV *SoundConv, WAVEFORMATEX *OutWaveFormat ) ;		// ϊ̉`擾( [] -1:G[  0ȏ:ϊ̃TCY )
extern	int GetSoundConvertEndState(      SOUNDCONV *SoundConv ) ;									// ϊIĂ邩ǂ擾( [] TRUE:I  FALSE:܂IĂȂ )
extern	int GetSoundConvertDestSize_Fast( SOUNDCONV *SoundConv ) ;									// ϊ̑}̃f[^TCY𓾂
extern	int SoundConvertFast(             SOUNDCONV *SoundConv, WAVEFORMATEX *FormatP, void **DestBufferP, int *DestSizeP ) ;	// Ȉꊇϊ


// ˑEI֐
extern	int InitializeSoundConvert_PF( void ) ;														// TEhf[^ϊ̊ˑ̏s
extern	int TerminateSoundConvert_PF( void ) ;														// TEhf[^ϊ̊ˑ̏Is

extern	int SetupSoundConvert_PF( SOUNDCONV *SoundConv, STREAMDATA *Stream, int DisableReadSoundFunctionMask ) ;	// (ˑ)ϊ̃ZbgAbv( [] -1:G[ )
extern	int SetSampleTimeSoundConvert_PF(    SOUNDCONV *SoundConv, int SampleTime ) ;					// (ˑ)ϊ̈ʒuύX( TvP )
extern	int ConvertProcessSoundConvert_PF(   SOUNDCONV *SoundConv ) ;									// (ˑ)ϊ̃obt@Ƀf[^[
extern	int TerminateSoundConvert_PF(        SOUNDCONV *SoundConv ) ;									// (ˑ)ϊ̌ns
extern	int GetSoundConvertDestSize_Fast_PF( SOUNDCONV *SoundConv ) ;									// (ˑ)ϊ̑}̃f[^TCY𓾂

#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif // __DXSOUNDCONVERT_H__
