#include "../PixelShader.h"


// sNZVF[_[̓
struct PS_INPUT
{
	float4 Diffuse         : COLOR0 ;		// fBt[YJ[
	float4 Specular        : COLOR1 ;		// XyLJ[
	float4 TexCoords0_1    : TEXCOORD0 ;	// eNX`WƃTueNX`W( x:eNX`Wx  y:eNX`Wy  z:TueNX`Wx  w:TueNX`Wy )

	float3 V_to_Eye        : TEXCOORD1 ;	// _W王ւ̃xNg( r[ )
	float4 Normal_Fog      : TEXCOORD2 ;	// x.y.z:@( r[ )  w:tHOp[^

#if LG0_USE
	float4 Light0_Dir_Gen  : TEXCOORD3 ;	// xyz:CgŐtxNg( r[ ) w:CgO
#endif
#if LG1_USE
	float4 Light1_Dir_Gen  : TEXCOORD4 ;	// xyz:CgP̋txNg( r[ ) w:CgP
#endif
#if LG2_USE
	float4 Light2_Dir_Gen  : TEXCOORD5 ;	// xyz:CgQ̋txNg( r[ ) w:CgQ
#endif

#if SHADOWMAP || SHADOWMAP_DRAW
	float3 ShadowMap0Pos   : TEXCOORD6 ;	// VhE}bvÕCgW( x, y, z )
#endif
#if SHADOWMAP
	float3 ShadowMap1Pos   : TEXCOORD7 ;	// VhE}bvP̃CgW( x, y, z )
	float3 ShadowMap2Pos   : TEXCOORD8 ;	// VhE}bvQ̃CgW( x, y, z )
#endif
} ;

// sNZVF[_[̏o
struct PS_OUTPUT
{
	float4 Color0           : SV_TARGET0 ;	// F
} ;





SamplerState g_DiffuseMapSampler            : register( s0 ) ;		// fBt[Y}bveNX`
Texture2D    g_DiffuseMapTexture            : register( t0 ) ;		// fBt[Y}bveNX`

#if BUMPMAP
SamplerState g_NormalMapSampler             : register( s1 ) ;		// @}bveNX`
Texture2D    g_NormalMapTexture             : register( t1 ) ;		// @}bveNX`
#endif // BUMPMAP

#if USE_SPETEX
SamplerState g_SpecularMapSampler           : register( s2 ) ;		// XyL}bveNX`
Texture2D    g_SpecularMapTexture           : register( t2 ) ;		// XyL}bveNX`
#endif // USE_SPETEX

#if TOON
SamplerState g_ToonDiffuseGradSampler       : register( s3 ) ;		// gD[_OpfBt[YJ[Of[VeNX`
Texture2D    g_ToonDiffuseGradTexture       : register( t3 ) ;		// gD[_OpfBt[YJ[Of[VeNX`

SamplerState g_ToonSpecularGradSampler      : register( s4 ) ;		// gD[_OpXyLJ[Of[VeNX`
Texture2D    g_ToonSpecularGradTexture      : register( t4 ) ;		// gD[_OpXyLJ[Of[VeNX`

#if TOON_SPHEREOP_MUL || TOON_SPHEREOP_ADD
SamplerState g_ToonSphereMapSampler         : register( s5 ) ;		// gD[_OpXtBA}bveNX`
Texture2D    g_ToonSphereMapTexture         : register( t5 ) ;		// gD[_OpXtBA}bveNX`
#endif // TOON_SPHEREOP_MUL || TOON_SPHEREOP_ADD
SamplerState g_ToonRGBtoVMaxRGBVolumeSampler: register( s6 ) ;		// gD[_OpRGBPxOap{[eNX`
Texture3D    g_ToonRGBtoVMaxRGBVolumeTexture: register( t6 ) ;		// gD[_OpRGBPxOap{[eNX`
#endif // TOON

#if SUBTEXTUREMODE != 0
SamplerState g_SubSampler                   : register( s7 ) ;		// TueNX`
Texture2D    g_SubTexture                   : register( t7 ) ;		// TueNX`
#endif // SUBTEXTUREMODE != 0

#if SHADOWMAP
SamplerState g_ShadowMap0Sampler            : register( s8  ) ;		// VhE}bvOeNX`
Texture2D    g_ShadowMap0Texture            : register( t8  ) ;		// VhE}bvOeNX`

SamplerState g_ShadowMap1Sampler            : register( s9  ) ;		// VhE}bvPeNX`
Texture2D    g_ShadowMap1Texture            : register( t9  ) ;		// VhE}bvPeNX`

SamplerState g_ShadowMap2Sampler            : register( s10 ) ;		// VhE}bvQeNX`
Texture2D    g_ShadowMap2Texture            : register( t10 ) ;		// VhE}bvQeNX`
#endif




// main֐
PS_OUTPUT main( PS_INPUT PSInput )
{
	PS_OUTPUT	PSOutput ;
	float4		TextureDiffuseColor ;
	float4		TextureSpecularColor ;
	float4		ToonSpecularGradColor ;
	float4		ToonDiffuseGradColor ;
	float4		ToonSphereMapColor ;
	float4		ToonRGBtoVMaxRGBVolumeColor ;
	float3		Normal ;
	float3		TotalDiffuse ;
	float3		TotalSpecular ;
	float3		TotalLightDiffuse ;
	float3		TotalAmbient ;
	float		TotalAngleGen ;
	float		DiffuseAngleGen ;
	float3		TempF3 ;
	float		Temp ;
	float3		ShadowRate ;
	float		ShadowGen ;
	float		ParamAlpha;

#if SHADOWMAP
	float2		DepthTexCoord ;
	float4		TextureDepth ;
//	float4		variance_md_p_pmax ;
#endif

	ParamAlpha = PSInput.Diffuse.a * g_Base.FactorColor.a;

#if SUBTEXTUREMODE != 0
	float4 SubTextureColor;
#endif  // SUBTEXTUREMODE != 0

	TextureDiffuseColor =  g_DiffuseMapTexture.Sample( g_DiffuseMapSampler, PSInput.TexCoords0_1.xy ) ;

#ifdef USE_SPE
	#ifdef USE_SPETEX
	TextureSpecularColor = g_SpecularMapTexture.Sample( g_SpecularMapSampler, PSInput.TexCoords0_1.xy ) ;
	#endif // USE_SPETEX
#endif // USE_SPE

#if SUBTEXTUREMODE != 0
	SubTextureColor = g_SubTexture.Sample( g_SubSampler, PSInput.TexCoords0_1.zw ) ;
#endif  // SUBTEXTUREMODE != 0

#if SUBTEXTUREMODE == 1  // uh( MV1_LAYERBLEND_TYPE_TRANSLUCENT + 1 )
	TextureDiffuseColor.rgb = lerp( TextureDiffuseColor.rgb, SubTextureColor.rgb, SubTextureColor.a ) ;
#endif // SUBTEXTUREMODE == 1

#if SUBTEXTUREMODE == 2  // Z( MV1_LAYERBLEND_TYPE_ADDITIVE + 1 )
	TextureDiffuseColor.rgb += SubTextureColor.rgb;
#endif // SUBTEXTUREMODE == 2

#if SUBTEXTUREMODE == 3  // Z( MV1_LAYERBLEND_TYPE_MODULATE + 1 )
	TextureDiffuseColor.rgb *= SubTextureColor.rgb;
#endif // SUBTEXTUREMODE == 3

#if SUBTEXTUREMODE == 4  // Z~Q( MV1_LAYERBLEND_TYPE_MODULATE2 + 1 )
	TextureDiffuseColor.rgb *= SubTextureColor.rgb * 2.0f;
#endif // SUBTEXTUREMODE == 4

	// CggȂꍇ̓J[̂܂܏o *****************************************( Jn )
	#ifndef LG_USE

		// VhE}bvւ̕` *********************************************************( Jn )
		#if SHADOWMAP_DRAW
			#if TOON
				#if TOON == 1
					// o̓ = eNX` * fBt[Y * 惿
					PSOutput.Color0.a = TextureDiffuseColor.a * ParamAlpha ;

				#else	// TOON == 1
					#if TOON_SPHEREOP_MUL
						Normal = normalize( PSInput.Normal_Fog.xyz ) ;
					
						// XtBA}bv̐F擾
						TempF3 = Normal * float3( 0.5f, -0.5f, 0.0f ) + 0.5f ;
						ToonSphereMapColor = g_ToonSphereMapTexture.Sample( g_ToonSphereMapSampler, TempF3.xy ) ;

						PSOutput.Color0.a = TextureDiffuseColor.a * ParamAlpha * ToonSphereMapColor.a ;

					#else // TOON_SPHEREOP_MUL

						PSOutput.Color0.a = TextureDiffuseColor.a * ParamAlpha ;

					#endif // TOON_SPHEREOP_MUL

				#endif		// TOON == 1
			#else  // TOON
			
				// o̓ = eNX` * fBt[Y * 惿
				PSOutput.Color0.a = TextureDiffuseColor.a * ParamAlpha ;
				
			#endif // TOON
			
			// ylFƂďo
			PSOutput.Color0.r = PSInput.ShadowMap0Pos.z;
			PSOutput.Color0.g = 0.0f ;
			PSOutput.Color0.b = 0.0f ;
		
		// VhE}bvւ̕` *********************************************************( I )
		#else // SHADOWMAP_DRAW
		
			#ifdef USE_SPE

				#ifdef USE_SPETEX

					PSOutput.Color0 = PSInput.Specular * TextureSpecularColor + PSInput.Diffuse * TextureDiffuseColor ;

				#else  // USE_SPETEX

					PSOutput.Color0 = PSInput.Specular + PSInput.Diffuse * TextureDiffuseColor ;

				#endif // USE_SPETEX

			#else  // USE_SPE

				PSOutput.Color0 = PSInput.Diffuse * TextureDiffuseColor ;

			#endif // USE_SPE

			PSOutput.Color0.a = TextureDiffuseColor.a * ParamAlpha ;
			
		#endif // SHADOWMAP_DRAW

	// CggȂꍇ̓J[̂܂܏o *****************************************( I )
	#else // LG_USE
	// Cggꍇ *******************************************************************( Jn )

		// ov}bv or tHVF[fBȌꍇ =========================================( Jn )
		#if BUMPMAP || PHONG

			#if BUMPMAP

				// @ 0`1 ̒l -1.0`1.0 ɕϊ
				Normal = ( g_NormalMapTexture.Sample( g_NormalMapSampler, PSInput.TexCoords0_1.xy ).rgb - 0.5f ) * 2.0f ;

			#else // BUMPMAP

				Normal = PSInput.Normal_Fog.xyz ;

			#endif // BUMPMAP


			#ifdef    PHONG
				Normal = normalize( Normal ) ;
			#endif

			#if	SHADOWMAP
				// _̃eNX`Wl͈͓̏ꍇ̂ݏ
				if( PSInput.ShadowMap0Pos.x < -1.0f || PSInput.ShadowMap0Pos.x > 1.0f ||
					PSInput.ShadowMap0Pos.y < -1.0f || PSInput.ShadowMap0Pos.y > 1.0f ||
					PSInput.ShadowMap0Pos.z <  0.0f || PSInput.ShadowMap0Pos.z > 1.0f )
				{
					ShadowRate.x = 1.0f;
				}
				else
				{
					// [xeNX`̍WZo
					// PSInput.ShadowMap0Pos.xy  -1.0f ` 1.0f ̒lȂ̂ŁA 0.0f ` 1.0f ̒lɂ
					DepthTexCoord.x = ( PSInput.ShadowMap0Pos.x + 1.0f ) / 2.0f;

					// y͍Xɏ㉺]
					DepthTexCoord.y = 1.0f - ( PSInput.ShadowMap0Pos.y + 1.0f ) / 2.0f;

					// [xobt@eNX`[x擾
					TextureDepth = g_ShadowMap0Texture.Sample( g_ShadowMap0Sampler, DepthTexCoord );

					// eNX`ɋL^Ă[x( +␳l )yl傫牜ɂƂƂŌőɂ
					ShadowRate.x = smoothstep( PSInput.ShadowMap0Pos.z - g_ShadowMap.Data[ 0 ].GradationParam, PSInput.ShadowMap0Pos.z, TextureDepth.r + g_ShadowMap.Data[ 0 ].AdjustDepth ) ;
				}

				// _̃eNX`Wl͈͓̏ꍇ̂ݏ
				if( PSInput.ShadowMap1Pos.x < -1.0f || PSInput.ShadowMap1Pos.x > 1.0f ||
					PSInput.ShadowMap1Pos.y < -1.0f || PSInput.ShadowMap1Pos.y > 1.0f ||
					PSInput.ShadowMap1Pos.z <  0.0f || PSInput.ShadowMap1Pos.z > 1.0f )
				{
					ShadowRate.y = 1.0f;
				}
				else
				{
					// [xeNX`̍WZo
					// PSInput.ShadowMap1Pos.xy  -1.0f ` 1.0f ̒lȂ̂ŁA 0.0f ` 1.0f ̒lɂ
					DepthTexCoord.x = ( PSInput.ShadowMap1Pos.x + 1.0f ) / 2.0f;

					// y͍Xɏ㉺]
					DepthTexCoord.y = 1.0f - ( PSInput.ShadowMap1Pos.y + 1.0f ) / 2.0f;

					// [xobt@eNX`[x擾
					TextureDepth = g_ShadowMap1Texture.Sample( g_ShadowMap1Sampler, DepthTexCoord );

					// eNX`ɋL^Ă[x( +␳l )yl傫牜ɂƂƂŌőɂ
					ShadowRate.y = smoothstep( PSInput.ShadowMap1Pos.z - g_ShadowMap.Data[ 1 ].GradationParam, PSInput.ShadowMap1Pos.z, TextureDepth.r + g_ShadowMap.Data[ 1 ].AdjustDepth ) ;
				}

				// _̃eNX`Wl͈͓̏ꍇ̂ݏ
				if( PSInput.ShadowMap2Pos.x < -1.0f || PSInput.ShadowMap2Pos.x > 1.0f ||
					PSInput.ShadowMap2Pos.y < -1.0f || PSInput.ShadowMap2Pos.y > 1.0f ||
					PSInput.ShadowMap2Pos.z <  0.0f || PSInput.ShadowMap2Pos.z > 1.0f )
				{
					ShadowRate.z = 1.0f;
				}
				else
				{
					// [xeNX`̍WZo
					// PSInput.ShadowMap2Pos.x  PSInput.ShadowMap2Pos.y  -1.0f ` 1.0f ̒lȂ̂ŁA 0.0f ` 1.0f ̒lɂ
					DepthTexCoord.x = ( PSInput.ShadowMap2Pos.x + 1.0f ) / 2.0f;

					// y͍Xɏ㉺]
					DepthTexCoord.y = 1.0f - ( PSInput.ShadowMap2Pos.y + 1.0f ) / 2.0f;

					// [xobt@eNX`[x擾
					TextureDepth = g_ShadowMap2Texture.Sample( g_ShadowMap2Sampler, DepthTexCoord );

					// eNX`ɋL^Ă[x( +␳l )yl傫牜ɂƂƂŌőɂ
					ShadowRate.z = smoothstep( PSInput.ShadowMap2Pos.z - g_ShadowMap.Data[ 2 ].GradationParam, PSInput.ShadowMap2Pos.z, TextureDepth.r + g_ShadowMap.Data[ 2 ].AdjustDepth ) ;
				}

			#else // SHADOWMAP
				ShadowRate.x = 1.0f ;
				ShadowRate.y = 1.0f ;
				ShadowRate.z = 1.0f ;
			#endif // SHADOWMAP

			// fBt[YJ[ƃXyLJ[̒~ϒl
			TotalDiffuse  = 0.0f ;
			TotalSpecular = 0.0f ;
			#if TOON
				#if TOON == 1
					TotalLightDiffuse = 0.0f ;
				#else // TOON == 1
					TotalAmbient = 0.0f ;
					TotalAngleGen = 0.0f ;
				#endif
			#endif // TOON




			
// Cg0̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )
#if LG0_USE

	// fBt[YFvZ

	// DiffuseAngleGen = fBt[YpxvZ
	DiffuseAngleGen = saturate( dot( Normal, PSInput.Light0_Dir_Gen.xyz ) ) ;
	
	// eɂ錸Zo
	ShadowGen = max( ShadowRate.x, g_ShadowMap.Data[ 0 ].Enable_Light0 ) *
	            max( ShadowRate.y, g_ShadowMap.Data[ 1 ].Enable_Light0 ) *
	            max( ShadowRate.z, g_ShadowMap.Data[ 2 ].Enable_Light0 ) ;

	#if LG0_DIR

		#if TOON
			#if TOON == 1
				// gD[̏ꍇ͂̎_ł͒_or}eÃfBt[YJ[͎gpȂ
				// fBt[YJ[~ϒl += Cg̃fBt[YJ[ * fBt[YJ[px + Cg̃ArGgJ[ƃ}eÃArGgJ[Z 
				TempF3             = g_Common.Light[ 0 ].Diffuse * DiffuseAngleGen * ShadowGen ;
				TotalLightDiffuse += TempF3 ;
				TotalDiffuse      += TempF3 + g_Common.Light[ 0 ].Ambient.xyz ;

			#else // TOON == 1
				// gD[Q̏ꍇ̓fBt[YJ[ƃCg̊px͕ʁXɕۑĂ
				// fBt[YJ[~ϒl   += Cg̃fBt[YJ[
				// Cg̊px̒~ϒl += Cg̊px
				// Cg̃ArGgJ[̒~ϒl += Cg̃ArGgJ[
				TotalDiffuse  += g_Common.Light[ 0 ].Diffuse ;

				TotalAmbient  += g_Common.Light[ 0 ].Ambient.rgb ;
				TotalAngleGen += DiffuseAngleGen * ShadowGen ;

			#endif // TOON == 1
		#else // TOON
			// fBt[YJ[~ϒl += Cg̃fBt[YJ[ * fBt[YJ[ * fBt[YJ[px + Cg̃ArGgJ[ƃ}eÃArGgJ[Z 
			TotalDiffuse += g_Common.Light[ 0 ].Diffuse * PSInput.Diffuse.xyz * DiffuseAngleGen * ShadowGen + g_Common.Light[ 0 ].Ambient.xyz ;

		#endif //TOON

	#else // LG0_DIR

		#if TOON
			#if TOON == 1
				// gD[̏ꍇ͂̎_ł͒_or}eÃfBt[YJ[͎gpȂ
				// fBt[YJ[~ϒl += ( Cg̃fBt[YJ[ * fBt[YJ[px + Cg̃ArGgJ[ƃ}eÃArGgJ[Z  ) * EX|bgCg̊px
				TempF3             = g_Common.Light[ 0 ].Diffuse * DiffuseAngleGen * ShadowGen ;
				TotalLightDiffuse += TempF3 * PSInput.Light0_Dir_Gen.w ;
				TotalDiffuse      += ( TempF3 + g_Common.Light[ 0 ].Ambient.xyz ) * PSInput.Light0_Dir_Gen.w ;

			#else // TOON == 1
				// gD[Q̏ꍇ̓fBt[YJ[ƃCg̊px͕ʁXɕۑĂ
				// fBt[YJ[~ϒl           += Cg̃fBt[YJ[
				// Cg̃ArGgJ[̒~ϒl += Cg̃ArGgJ[
				// Cg̊px̒~ϒl         += Cg̊px
				TotalDiffuse  += g_Common.Light[ 0 ].Diffuse ;

				TotalAmbient  += g_Common.Light[ 0 ].Ambient.rgb ;
				TotalAngleGen += DiffuseAngleGen * ShadowGen * PSInput.Light0_Dir_Gen.w ;

			#endif // TOON == 1
		#else // TOON
			// fBt[YJ[~ϒl += ( Cg̃fBt[YJ[ * fBt[YJ[ * fBt[YJ[px + Cg̃ArGgJ[ƃ}eÃArGgJ[Z  ) * EX|bgCg̊px
			TotalDiffuse += ( g_Common.Light[ 0 ].Diffuse * PSInput.Diffuse.xyz * DiffuseAngleGen * ShadowGen + g_Common.Light[ 0 ].Ambient.xyz ) * PSInput.Light0_Dir_Gen.w ;
			
		#endif // TOON

	#endif // LG0_DIR


	// XyLJ[vZ
	#ifdef USE_SPE

		// n[txNǧvZ
		TempF3 = PSInput.V_to_Eye + PSInput.Light0_Dir_Gen.xyz ;
		#ifdef    PHONG
			TempF3 = normalize( TempF3 ) ;
		#else  // PHONG
			TempF3 *= 0.5f ;
		#endif // PHONG

		// Temp = pow( max( 0.0f, N * H ), g_Common.Material.Power )
		Temp = pow( max( 0.0f, dot( Normal, TempF3 ) ), g_Common.Material.Power ) ;

		#if LG0_DIR

			// XyLJ[~ϒl += Temp * Cg̃XyLJ[
			TotalSpecular += Temp * g_Common.Light[ 0 ].Specular * ShadowGen ;

		#else // LG0_DIR

			// XyLJ[~ϒl += Temp * EX|bgCg̊px * Cg̃XyLJ[
			TotalSpecular += Temp * PSInput.Light0_Dir_Gen.w * g_Common.Light[ 0 ].Specular * ShadowGen ;

		#endif // LG0_DIR

	#endif // USE_SPE

#endif // LG0_USE
// Cg0̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )









			
// Cg1̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )
#if LG1_USE

	// fBt[YFvZ

	// DiffuseAngleGen = fBt[YpxvZ
	DiffuseAngleGen = saturate( dot( Normal, PSInput.Light1_Dir_Gen.xyz ) ) ;
	
	// eɂ錸Zo
	ShadowGen = max( ShadowRate.x, g_ShadowMap.Data[ 0 ].Enable_Light1 ) *
	            max( ShadowRate.y, g_ShadowMap.Data[ 1 ].Enable_Light1 ) *
	            max( ShadowRate.z, g_ShadowMap.Data[ 2 ].Enable_Light1 ) ;

	#if LG1_DIR

		#if TOON
			#if TOON == 1
				// gD[̏ꍇ͂̎_ł͒_or}eÃfBt[YJ[͎gpȂ
				// fBt[YJ[~ϒl += Cg̃fBt[YJ[ * fBt[YJ[px + Cg̃ArGgJ[ƃ}eÃArGgJ[Z 
				TempF3             = g_Common.Light[ 1 ].Diffuse * DiffuseAngleGen * ShadowGen ;
				TotalLightDiffuse += TempF3 ;
				TotalDiffuse      += TempF3 + g_Common.Light[ 1 ].Ambient.xyz ;

			#else // TOON == 1
				// gD[Q̏ꍇ̓fBt[YJ[ƃCg̊px͕ʁXɕۑĂ
				// fBt[YJ[~ϒl   += Cg̃fBt[YJ[
				// Cg̊px̒~ϒl += Cg̊px
				// Cg̃ArGgJ[̒~ϒl += Cg̃ArGgJ[
				TotalDiffuse  += g_Common.Light[ 1 ].Diffuse ;

				TotalAmbient  += g_Common.Light[ 1 ].Ambient.rgb ;
				TotalAngleGen += DiffuseAngleGen * ShadowGen ;

			#endif // TOON == 1
		#else // TOON
			// fBt[YJ[~ϒl += Cg̃fBt[YJ[ * fBt[YJ[ * fBt[YJ[px + Cg̃ArGgJ[ƃ}eÃArGgJ[Z 
			TotalDiffuse += g_Common.Light[ 1 ].Diffuse * PSInput.Diffuse.xyz * DiffuseAngleGen * ShadowGen + g_Common.Light[ 1 ].Ambient.xyz ;

		#endif //TOON

	#else // LG1_DIR

		#if TOON
			#if TOON == 1
				// gD[̏ꍇ͂̎_ł͒_or}eÃfBt[YJ[͎gpȂ
				// fBt[YJ[~ϒl += ( Cg̃fBt[YJ[ * fBt[YJ[px + Cg̃ArGgJ[ƃ}eÃArGgJ[Z  ) * EX|bgCg̊px
				TempF3             = g_Common.Light[ 1 ].Diffuse * DiffuseAngleGen * ShadowGen ;
				TotalLightDiffuse += TempF3 * PSInput.Light1_Dir_Gen.w ;
				TotalDiffuse      += ( TempF3 + g_Common.Light[ 1 ].Ambient.xyz ) * PSInput.Light1_Dir_Gen.w ;

			#else // TOON == 1
				// gD[Q̏ꍇ̓fBt[YJ[ƃCg̊px͕ʁXɕۑĂ
				// fBt[YJ[~ϒl           += Cg̃fBt[YJ[
				// Cg̃ArGgJ[̒~ϒl += Cg̃ArGgJ[
				// Cg̊px̒~ϒl         += Cg̊px
				TotalDiffuse  += g_Common.Light[ 1 ].Diffuse ;

				TotalAmbient  += g_Common.Light[ 1 ].Ambient.rgb ;
				TotalAngleGen += DiffuseAngleGen * ShadowGen * PSInput.Light1_Dir_Gen.w ;

			#endif // TOON == 1
		#else // TOON
			// fBt[YJ[~ϒl += ( Cg̃fBt[YJ[ * fBt[YJ[ * fBt[YJ[px + Cg̃ArGgJ[ƃ}eÃArGgJ[Z  ) * EX|bgCg̊px
			TotalDiffuse += ( g_Common.Light[ 1 ].Diffuse * PSInput.Diffuse.xyz * DiffuseAngleGen * ShadowGen + g_Common.Light[ 1 ].Ambient.xyz ) * PSInput.Light1_Dir_Gen.w ;
			
		#endif // TOON

	#endif // LG1_DIR


	// XyLJ[vZ
	#ifdef USE_SPE

		// n[txNǧvZ
		TempF3 = PSInput.V_to_Eye + PSInput.Light1_Dir_Gen.xyz ;
		#ifdef    PHONG
			TempF3 = normalize( TempF3 ) ;
		#else  // PHONG
			TempF3 *= 0.5f ;
		#endif // PHONG

		// Temp = pow( max( 0.0f, N * H ), g_Common.Material.Power )
		Temp = pow( max( 0.0f, dot( Normal, TempF3 ) ), g_Common.Material.Power ) ;

		#if LG1_DIR

			// XyLJ[~ϒl += Temp * Cg̃XyLJ[
			TotalSpecular += Temp * g_Common.Light[ 1 ].Specular * ShadowGen ;

		#else // LG1_DIR

			// XyLJ[~ϒl += Temp * EX|bgCg̊px * Cg̃XyLJ[
			TotalSpecular += Temp * PSInput.Light1_Dir_Gen.w * g_Common.Light[ 1 ].Specular * ShadowGen ;

		#endif // LG1_DIR

	#endif // USE_SPE

#endif // LG1_USE
// Cg1̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )









			
// Cg2̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )
#if LG2_USE

	// fBt[YFvZ

	// DiffuseAngleGen = fBt[YpxvZ
	DiffuseAngleGen = saturate( dot( Normal, PSInput.Light2_Dir_Gen.xyz ) ) ;
	
	// eɂ錸Zo
	ShadowGen = max( ShadowRate.x, g_ShadowMap.Data[ 0 ].Enable_Light2 ) *
	            max( ShadowRate.y, g_ShadowMap.Data[ 1 ].Enable_Light2 ) *
	            max( ShadowRate.z, g_ShadowMap.Data[ 2 ].Enable_Light2 ) ;

	#if LG2_DIR

		#if TOON
			#if TOON == 1
				// gD[̏ꍇ͂̎_ł͒_or}eÃfBt[YJ[͎gpȂ
				// fBt[YJ[~ϒl += Cg̃fBt[YJ[ * fBt[YJ[px + Cg̃ArGgJ[ƃ}eÃArGgJ[Z 
				TempF3             = g_Common.Light[ 2 ].Diffuse * DiffuseAngleGen * ShadowGen ;
				TotalLightDiffuse += TempF3 ;
				TotalDiffuse      += TempF3 + g_Common.Light[ 2 ].Ambient.xyz ;

			#else // TOON == 1
				// gD[Q̏ꍇ̓fBt[YJ[ƃCg̊px͕ʁXɕۑĂ
				// fBt[YJ[~ϒl   += Cg̃fBt[YJ[
				// Cg̊px̒~ϒl += Cg̊px
				// Cg̃ArGgJ[̒~ϒl += Cg̃ArGgJ[
				TotalDiffuse  += g_Common.Light[ 2 ].Diffuse ;

				TotalAmbient  += g_Common.Light[ 2 ].Ambient.rgb ;
				TotalAngleGen += DiffuseAngleGen * ShadowGen ;

			#endif // TOON == 1
		#else // TOON
			// fBt[YJ[~ϒl += Cg̃fBt[YJ[ * fBt[YJ[ * fBt[YJ[px + Cg̃ArGgJ[ƃ}eÃArGgJ[Z 
			TotalDiffuse += g_Common.Light[ 2 ].Diffuse * PSInput.Diffuse.xyz * DiffuseAngleGen * ShadowGen + g_Common.Light[ 2 ].Ambient.xyz ;

		#endif //TOON

	#else // LG2_DIR

		#if TOON
			#if TOON == 1
				// gD[̏ꍇ͂̎_ł͒_or}eÃfBt[YJ[͎gpȂ
				// fBt[YJ[~ϒl += ( Cg̃fBt[YJ[ * fBt[YJ[px + Cg̃ArGgJ[ƃ}eÃArGgJ[Z  ) * EX|bgCg̊px
				TempF3             = g_Common.Light[ 2 ].Diffuse * DiffuseAngleGen * ShadowGen ;
				TotalLightDiffuse += TempF3 * PSInput.Light2_Dir_Gen.w ;
				TotalDiffuse      += ( TempF3 + g_Common.Light[ 2 ].Ambient.xyz ) * PSInput.Light2_Dir_Gen.w ;

			#else // TOON == 1
				// gD[Q̏ꍇ̓fBt[YJ[ƃCg̊px͕ʁXɕۑĂ
				// fBt[YJ[~ϒl           += Cg̃fBt[YJ[
				// Cg̃ArGgJ[̒~ϒl += Cg̃ArGgJ[
				// Cg̊px̒~ϒl         += Cg̊px
				TotalDiffuse  += g_Common.Light[ 2 ].Diffuse ;

				TotalAmbient  += g_Common.Light[ 2 ].Ambient.rgb ;
				TotalAngleGen += DiffuseAngleGen * ShadowGen * PSInput.Light2_Dir_Gen.w ;

			#endif // TOON == 1
		#else // TOON
			// fBt[YJ[~ϒl += ( Cg̃fBt[YJ[ * fBt[YJ[ * fBt[YJ[px + Cg̃ArGgJ[ƃ}eÃArGgJ[Z  ) * EX|bgCg̊px
			TotalDiffuse += ( g_Common.Light[ 2 ].Diffuse * PSInput.Diffuse.xyz * DiffuseAngleGen * ShadowGen + g_Common.Light[ 2 ].Ambient.xyz ) * PSInput.Light2_Dir_Gen.w ;
			
		#endif // TOON

	#endif // LG2_DIR


	// XyLJ[vZ
	#ifdef USE_SPE

		// n[txNǧvZ
		TempF3 = PSInput.V_to_Eye + PSInput.Light2_Dir_Gen.xyz ;
		#ifdef    PHONG
			TempF3 = normalize( TempF3 ) ;
		#else  // PHONG
			TempF3 *= 0.5f ;
		#endif // PHONG

		// Temp = pow( max( 0.0f, N * H ), g_Common.Material.Power )
		Temp = pow( max( 0.0f, dot( Normal, TempF3 ) ), g_Common.Material.Power ) ;

		#if LG2_DIR

			// XyLJ[~ϒl += Temp * Cg̃XyLJ[
			TotalSpecular += Temp * g_Common.Light[ 2 ].Specular * ShadowGen ;

		#else // LG2_DIR

			// XyLJ[~ϒl += Temp * EX|bgCg̊px * Cg̃XyLJ[
			TotalSpecular += Temp * PSInput.Light2_Dir_Gen.w * g_Common.Light[ 2 ].Specular * ShadowGen ;

		#endif // LG2_DIR

	#endif // USE_SPE

#endif // LG2_USE
// Cg2̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )


















			// o̓J[vZ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )

			#if TOON != 2
				// TotalDiffuse = CgfBt[YJ[~ϒl + ( }eÃArGgJ[ƃO[oArGgJ[Ẑƃ}eAG~bVuJ[Z )
				TotalDiffuse += g_Common.Material.Ambient_Emissive.xyz ;
			#else // TOON != 2
				// ArGgJ[̒~ϒl += }eÃArGgJ[ƃO[oArGgJ[Ẑƃ}eAG~bVuJ[Z
				TotalAmbient += g_Common.Material.Ambient_Emissive.rgb ;
			#endif  // TOON != 2

			#ifdef USE_SPE
				#if TOON
					#if TOON == 1
						// gD[P̎̏o͌vZ
						ToonSpecularGradColor = g_ToonSpecularGradTexture.Sample( g_ToonSpecularGradSampler, max( TotalSpecular.b, max( TotalSpecular.r, TotalSpecular.g ) ) ) ;
					
						#ifdef USE_SPETEX
							TextureSpecularColor.rgb *= ToonSpecularGradColor.rgb ;
						#else  // USE_SPETEX
							TextureSpecularColor = ToonSpecularGradColor ;
						#endif // USE_SPETEX
					
						TextureSpecularColor.rgb *= g_ToonRGBtoVMaxRGBVolumeTexture.Sample( g_ToonRGBtoVMaxRGBVolumeSampler, TotalSpecular ).rgb * PSInput.Specular.rgb ;

						TextureDiffuseColor.rgb *= g_ToonRGBtoVMaxRGBVolumeTexture.Sample( g_ToonRGBtoVMaxRGBVolumeSampler, TotalLightDiffuse ).rgb * PSInput.Diffuse.rgb ;

						ToonDiffuseGradColor = g_ToonDiffuseGradTexture.Sample( g_ToonDiffuseGradSampler, max( TotalDiffuse.b, max( TotalDiffuse.r, TotalDiffuse.g ) ) ) ;

						#if TOON_DIFOP_MUL
							PSOutput.Color0 = TextureDiffuseColor * ToonDiffuseGradColor ;
						#endif // TOON_DIFOP_MUL
						#if TOON_DIFOP_TRANS
							PSOutput.Color0 = lerp( TextureDiffuseColor, ToonDiffuseGradColor, ToonDiffuseGradColor.a ) ;
						#endif // TOON_DIFOP_TRANS

						#if TOON_SPEOP_ADD
							PSOutput.Color0 = PSOutput.Color0 + TextureSpecularColor ;
						#endif // TOON_SPEOP_ADD
						#if TOON_SPEOP_TRANS
							PSOutput.Color0 = lerp( PSOutput.Color0, TextureSpecularColor, TextureSpecularColor.a ) ;
						#endif // TOON_SPEOP_TRANS

						#if TOON_DIFOP_MUL
							ParamAlpha *= ToonDiffuseGradColor.a ;
						#endif // TOON_DIFOP_MUL

						PSOutput.Color0.a = TextureDiffuseColor.a * ParamAlpha ;
					
					#else  // TOON == 1
						// gD[Q̎̏o͌vZ
						ToonDiffuseGradColor = g_ToonDiffuseGradTexture.Sample( g_ToonDiffuseGradSampler, TotalAngleGen ) ;

						// o = saturate( saturate( ArGgJ[̒~ϒl + }eÃfBt[YJ[ * Cg̃fBt[YJ[̒~ϒl ) * eNX`Of[VJ[ + XyLJ[~ϒl * }eÃXyLJ[ ) * eNX`J[
						PSOutput.Color0.rgb = saturate( saturate( TotalDiffuse * PSInput.Diffuse.rgb + TotalAmbient ) * ToonDiffuseGradColor.rgb + PSInput.Specular.rgb * TotalSpecular ) * TextureDiffuseColor.rgb ;
					
						#if TOON_SPHEREOP_MUL || TOON_SPHEREOP_ADD
							// XtBA}bv̐F擾
							TempF3 = Normal * float3( 0.5f, -0.5f, 0.0f ) + 0.5f ;
							ToonSphereMapColor = g_ToonSphereMapTexture.Sample( g_ToonSphereMapSampler, TempF3.xy ) ;
						
							#if TOON_SPHEREOP_MUL
								// XtBA}bv̐Fo͂ɏZ
								PSOutput.Color0.rgb *= ToonSphereMapColor.rgb ;
							#endif // TOON_SPHEREOP_MUL
						
							#if TOON_SPHEREOP_ADD
								// XtBA}bv̐Fo͂ɉZ
								PSOutput.Color0.rgb += ToonSphereMapColor.rgb ;
							#endif // TOON_SPHEREOP_ADD
						
						#endif // TOON_SPHEREOP_MUL || TOON_SPHEREOP_ADD

						#if TOON_SPHEREOP_MUL 

							// o̓At@ = eNX`At@ * FactorAt@ * _At@ * XtBA}bvAt@
							PSOutput.Color0.a = TextureDiffuseColor.a * ParamAlpha * ToonSphereMapColor.a ;

						#else // TOON_SPHEREOP_MUL

							// o̓At@ = eNX`At@ * FactorAt@ * _At@
							PSOutput.Color0.a = TextureDiffuseColor.a * ParamAlpha ;

						#endif // TOON_SPHEREOP_MUL

					#endif   // TOON == 1
				#else  // TOON

					#ifdef USE_SPETEX
						// TextureSpecularColor = Cg̃XyLJ[~ϒl * XyLJ[ * XyLeNX`J[
						TextureSpecularColor.xyz = g_SpecularMapTexture.Sample( g_SpecularMapSampler, PSInput.TexCoords0_1.xy ).xyz * TotalSpecular * PSInput.Specular.xyz ;
					#else  // USE_SPETEX
						// TextureSpecularColor = Cg̃XyLJ[~ϒl * XyLJ[
						TextureSpecularColor.xyz = TotalSpecular.xyz * PSInput.Specular.xyz ;
					#endif // USE_SPETEX

					// o̓J[ = TotalDiffuse * eNX`J[ + TextureSpecularColor

					PSOutput.Color0.rgb = TextureDiffuseColor.rgb * TotalDiffuse + TextureSpecularColor.rgb ;
					PSOutput.Color0.a = TextureDiffuseColor.a * ParamAlpha ;

				#endif // TOON

			#else  // USE_SPE

				#if TOON
					#if TOON == 1
						ToonDiffuseGradColor = g_ToonDiffuseGradTexture.Sample( g_ToonDiffuseGradSampler, max( TotalDiffuse.b, max( TotalDiffuse.r, TotalDiffuse.g ) ) ) ;
						TextureDiffuseColor.rgb *= g_ToonRGBtoVMaxRGBVolumeTexture.Sample( g_ToonRGBtoVMaxRGBVolumeSampler, TotalLightDiffuse ).rgb * PSInput.Diffuse.rgb ;

						#if TOON_DIFOP_MUL
							// o̓J[ = eNX`J[ * fBt[YJ[~ϒl * Of[VJ[
							PSOutput.Color0 = TextureDiffuseColor * ToonDiffuseGradColor ;
						#endif // TOON_DIFOP_MUL
						#if TOON_DIFOP_TRANS
							// o̓J[ = Of[VJ[ * Of[V + ( 1 - Of[V ) * ( eNX`J[ * fBt[YJ[~ϒl )
							PSOutput.Color0 = lerp( TextureDiffuseColor, ToonDiffuseGradColor, ToonDiffuseGradColor.a ) ;
						#endif // TOON_DIFOP_TRANS

						// Z̏ꍇ̓lOf[VƏZ
						#if TOON_DIFOP_MUL
							ParamAlpha *= ToonDiffuseGradColor.a ;
						#endif // TOON_DIFOP_MUL

						// o̓ = eNX` * fBt[Y * 惿
						PSOutput.Color0.a = TextureDiffuseColor.a * ParamAlpha ;

					#else	// TOON == 1
						// gD[Q̎̏o͌vZ
						ToonDiffuseGradColor = g_ToonDiffuseGradTexture.Sample( g_ToonDiffuseGradSampler, TotalAngleGen ) ;

						// o = ( ArGgJ[̒~ϒl + }eÃfBt[YJ[ * Cg̃fBt[YJ[̒~ϒl ) * eNX`Of[VJ[ * eNX`J[
						PSOutput.Color0.rgb = saturate( TotalDiffuse * PSInput.Diffuse.rgb + TotalAmbient.rgb ) * ToonDiffuseGradColor.rgb * TextureDiffuseColor.rgb ;

						#if TOON_SPHEREOP_MUL || TOON_SPHEREOP_ADD
							// XtBA}bv̐F擾
							TempF3 = Normal * float3( 0.5f, -0.5f, 0.0f ) + 0.5f ;
							ToonSphereMapColor = g_ToonSphereMapTexture.Sample( g_ToonSphereMapSampler, TempF3.xy ) ;
						
							#if TOON_SPHEREOP_MUL
								// XtBA}bv̐Fo͂ɏZ
								PSOutput.Color0.rgb *= ToonSphereMapColor.rgb ;
							#endif // TOON_SPHEREOP_MUL
						
							#if TOON_SPHEREOP_ADD
								// XtBA}bv̐Fo͂ɉZ
								PSOutput.Color0.rgb += ToonSphereMapColor.rgb ;
							#endif // TOON_SPHEREOP_ADD
						
						#endif // TOON_SPHEREOP_MUL || TOON_SPHEREOP_ADD

						#if TOON_SPHEREOP_MUL

							PSOutput.Color0.a = TextureDiffuseColor.a * ParamAlpha * ToonSphereMapColor.a ;

						#else // TOON_SPHEREOP_MUL

							PSOutput.Color0.a = TextureDiffuseColor.a * ParamAlpha ;

						#endif // TOON_SPHEREOP_MUL

					#endif		// TOON == 1
				#else  // TOON
					// o̓J[ = TotalDiffuse * eNX`J[
					PSOutput.Color0.rgb = TotalDiffuse * TextureDiffuseColor.rgb ;

					// o̓ = eNX` * fBt[Y * 惿
					PSOutput.Color0.a = TextureDiffuseColor.a * ParamAlpha ;
				#endif // TOON

			#endif // USE_SPE

			// o̓J[vZ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )


		// ov}bv or tHVF[fBȌꍇ =========================================( I )
		#else  // BUMPMAP || PHONG
			// ov}bv or tHVF[fBOł͂Ȃꍇ ===================================( Jn )

			#ifdef USE_SPE

				#ifdef USE_SPETEX

					PSOutput.Color0.rgb = TextureDiffuseColor.rgb * PSInput.Diffuse.rgb + TextureSpecularColor.rgb * PSInput.Specular.rgb ;

				#else  // USE_SPETEX

					PSOutput.Color0.rgb = TextureDiffuseColor.rgb * PSInput.Diffuse.rgb + PSInput.Specular.rgb ;

				#endif // USE_SPETEX

			#else  // USE_SPE

				PSOutput.Color0.rgb = TextureDiffuseColor.rgb * PSInput.Diffuse.rgb ;

			#endif // USE_SPE

			PSOutput.Color0.a   = TextureDiffuseColor.a   * ParamAlpha ;

		#endif // BUMPMAP || PHONG
		// ov}bv or tHVF[fBOł͂Ȃꍇ ===================================( I )

	#endif // LG_USE
	// Cggꍇ *******************************************************************( I )

	// At@eXg
	AlphaTest( PSOutput.Color0.a ) ;

	// tHO
	PSOutput.Color0.rgb = lerp( g_Common.Fog.Color.rgb, PSOutput.Color0.rgb, saturate( PSInput.Normal_Fog.w ) );

	// At@ZJ[
	if( g_Base.MulAlphaColor.x > 0.5f )
	{
		PSOutput.Color0.rgb *= PSOutput.Color0.a;
	}

	return PSOutput ;
}

